#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ld long double
const ld INF = 1e17;

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve();
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> gr(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    if (k == 0) {
        cout << "";
        return;
    }
    vector<int> dist(n, -1);
    queue<int> q;
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        p--;
        dist[p] = h;
        q.push(p);
    }
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u: gr[v]) {
            if (dist[u] < dist[v] - 1) {
                dist[u] = dist[v] - 1;
                q.push(u);
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (dist[i] != -1) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (int i: ans) {
        cout << i << ' ';
    }
}