#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ld long double
const ld INF = 1e17;

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve();
    }
}

ld dist(ld a, ld b, ld c, ld d) {
    return sqrtl((a - c) * (a - c) + (b - d) * (b - d));
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    int sz = 1 << n;
    vector<ld> dp(sz, INF);
    for (int i = 0; i < n; i++) {
        dp[1 << i] = 0;
    }
    for (int i = 1; i < sz; i++) {
        if (dp[i] == 0) continue;
        for (int j = 0; j < n; j++) {
            if (i & (1 << j)) {
                int now = i ^ (1 << j);
                ld mn = INF;
                for (int k = 0; k < n; k++) {
                    if (now & (1 << k)) {
                        mn = min(mn, dp[now] + dist(a[j].first, a[j].second, a[k].first, a[k].second));
                    }
                }
                dp[i] = min(dp[i], mn);
            }
        }
    }
    cout << fixed << setprecision(10);
    cout << dp.back();
}